package com.freesource.actions;

import com.freesource.bean.UserBean;
import com.freesource.security.*;
import org.apache.struts.actions.DispatchAction;
import org.apache.struts.action.*;
import javax.servlet.http.*;
import org.apache.log4j.Logger;
import org.apache.struts.action.DynaActionForm;
import com.freesource.constants.Constants; 

public class LoginAction extends DispatchAction{
	
	Logger logger = Logger.getLogger(LoginAction.class);
	
 	public ActionForward login(ActionMapping map,ActionForm form,HttpServletRequest request,HttpServletResponse response) throws Exception{
	    
	 	ActionErrors errors = new ActionErrors();
	 	ActionForward forward = null;
	 	 
		DynaActionForm loginForm = (DynaActionForm)form;
		
		String userName = (String)loginForm.get(Constants.USERNAME_PARAMETER);
		String password = (String)loginForm.get(Constants.PASSWORD_PARAMETER);
		request.getSession(true).removeAttribute(Constants.USER_BEAN_NAME);
	 
		try{
			logger.info("login: " + userName);
			AuthenticationModule authenticationModule = new AuthenticationModule(userName,password);
			UserBean userBean = authenticationModule.login();		 
			logger.info("autenticazione riuscita per: " + userName);
		 	request.getSession(true).setAttribute(Constants.USER_BEAN_NAME,userBean);
		 	forward = map.findForward(Constants.FORWARD_LOGIN_SUCCESS);
		 	
		}catch(com.freesource.security.AuthenticationException e){
			
			logger.info("auteticazione fallita!");
			
			int errorcode = e.getErrorCode();	
			if (errorcode==AuthenticationException.USERS_NOT_EXIST) {
		 		logger.info("utente non presente: " + userName);
				errors.add(Constants.LOGIN_ERROR,new ActionMessage(Constants.ERROR_USER_NOT_EXIST));
				 
			}
			if (errorcode==AuthenticationException.INVALID_PASSWORD) {
				logger.info("password errata per: " + userName);
				errors.add(Constants.LOGIN_ERROR,new ActionMessage(Constants.ERROR_INVALID_PASSWORD));
				 
			}
			
		 	if (errors.size()==0) errors.add(Constants.LOGIN_ERROR,new ActionMessage(Constants.ERROR_GENERIC));
			logger.info(e.toString());
			this.saveErrors(request,errors);
			forward = map.findForward(Constants.FORWARD_LOGIN_FAILED);
			
		} 
	 
	 
		return forward;
	 
	}
}
