package com.freesource.actions;

import org.apache.struts.action.*;
import javax.servlet.http.*;
import com.freesource.bean.UserBean;
import com.freesource.security.RegisterUser;
import com.freesource.security.AuthenticationUtil;
import com.freesource.constants.Constants;
import org.apache.struts.Globals;
import org.apache.log4j.Logger;

public class RegisterAction extends Action {
 
 Logger logger = Logger.getLogger(LoginAction.class);
		
 public ActionForward execute(ActionMapping map,ActionForm form,HttpServletRequest request,HttpServletResponse response) throws Exception{
 
 		ActionForward forward = map.findForward(Constants.FORWARD_REGISTER);
 		ActionErrors errors = new ActionErrors();
		UserBean userBean = (UserBean)form;
		
	 
		String password = (String)request.getParameter(Constants.PASSWORD_PARAMETER);
	 	String confirmPassword = (String)request.getParameter(Constants.CONFIRM_PASSWORD_PARAMETER);
	    
	    logger.info("creazione della password criptata ...");
	 	byte pass[] = AuthenticationUtil.createPassword(password.getBytes(),null);	 	
	 	logger.info("verifica password: lunghezza criptata "  + String.valueOf(pass.length));
	 	
	 	boolean result = AuthenticationUtil.verify(confirmPassword.getBytes(),pass);
	 	forward = map.findForward(Constants.FORWARD_REGISTER);
		
	 	if (!result) {
	 		
	 		errors.add(Constants.REGISTER_ERROR,new ActionMessage(Constants.ERROR_CONFIRM_PASSWORD_ERROR));		
			logger.info("le due password non coincidono ..");
			
		}else{
			
			RegisterUser registerUser = new RegisterUser(userBean,pass);
			logger.info("registrazione dell'utente in corso ...");			
			result = registerUser.register();			
			if (!result) {
				
				logger.info("l'utente gi esiste ...");						
				errors.add(Constants.REGISTER_ERROR,new ActionMessage(Constants.ERROR_USER_EXIST));
				
			}
		 
		}
	
	 	
		if (errors.size()==0) {
						
			forward = map.findForward(Constants.FORWARD_LOGIN);		
		 	ActionMessages messages = new ActionMessages();
         	messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("globalMessage"));
      		request.setAttribute(Globals.MESSAGE_KEY, messages);
		 	logger.info("registrazione avvenuta con successo.");
		 		
		}else this.saveErrors(request,errors);	 
		 
		return forward;
  
 }
 
}
